Ruby - Bug #13513

Resolv::DNS::Message.decode hangs after detecting truncation in UDP messages
04/26/2017 04:13 PM - iamasmith (Andrew Smith)

Status: Closed
Priority: Normal
Assignee: akr (Akira Tanaka)

Target version:

ruby -v: Backport: 2.2: UNKNOWN, 2.3: UNKNOWN, 2.4:
UNKNOWN

Description

ruby-core:32407 introduced support for a TCP requestor in fetch_resource if Resolv::DNS::Message.decode returned
RCode::NoError and a reply tc of 1.

Unfortunately Resolv::DNS::Message.decode proceeds to attempt to unpack all answers based upon the answer count from the
message regardless of truncation which causes exception behaviour which is then silently retried as this is seen as the response to
the request never being seen (see begin, ensure).

To avoid this issue | add a return to Message.decode once the truncation is detected.

To patch this in a portable fashion | use the attached monkey patch which causes the truncation to propagate correctly back to
fetch_resource and allows it to proceed correctly with the TCP based query.

Associated revisions

Revision 974d18fd0c13bd19120cad70187f5b646¢c901dff - 11/24/2023 07:17 PM - jeremyevans (Jeremy Evans)
[ruby/resolv] Fix the fallback from UDP to TCP due to message truncation

If truncation is detected, return immediately from decode so that

the UDP connection can be retried with TCP, instead of failing to

decode due to trying to decode a truncated response.

Fixes [Bug #13513]

https://github.com/ruby/resolv/commit/0de996dbca

Revision 974d18fd0c13bd19120cad70187f5b646c901dff - 11/24/2023 07:17 PM - jeremyevans (Jeremy Evans)
[ruby/resolv] Fix the fallback from UDP to TCP due to message truncation

If truncation is detected, return immediately from decode so that

the UDP connection can be retried with TCP, instead of failing to

decode due to trying to decode a truncated response.

Fixes [Bug #13513]

https://github.com/ruby/resolv/commit/0de996dbca

Revision 974d18fd - 11/24/2023 07:17 PM - jeremyevans (Jeremy Evans)
[ruby/resolv] Fix the fallback from UDP to TCP due to message truncation

If truncation is detected, return immediately from decode so that

the UDP connection can be retried with TCP, instead of failing to

decode due to trying to decode a truncated response.

Fixes [Bug #13513]

https://github.com/ruby/resolv/commit/0de996dbca

History

#1 - 04/26/2017 05:32 PM - iamasmith (Andrew Smith)

After further consideration | had a look at rfc1035 with regard to the handling of record counts in truncated messages and it discusses ANCOUNT as
being the number of answers in the answer section and not necessarily the number of answers that the DNS server knows about.
I'm testing against SkyDNS and this appears to return in my test the 50 records that | added as the number for the ANCOUNT field but does correctly
report truncated.

The validity of the change | mention to Ruby perhaps is less correct if SkyDNS is at fault and it is appropriate that it is fixed, however, since Ruby
implements the suggested fallback to use TCP the records provided in the UDP response are not available to the caller and therefore the change to
handle excessive counts in ANCOUNT on truncated messages seems useful for the growing number of environments using SkyDNS.

I'll compare some others and potentially raise a separate bug if appropriate with the SkyDNS maintainers.
#2 - 07/15/2017 11:25 AM - shyouhei (Shyouhei Urabe)

- Status changed from Open to Assigned

- Assignee set to akr (Akira Tanaka)

#3 - 03/08/2021 11:35 PM - jeremyevans0 (Jeremy Evans)

I've confirmed this bug is still present in the current resolv library, and have submitted a patch to fix it: https:/github.com/ruby/resolv/pull/6

#4 - 11/24/2023 07:17 PM - jeremyevans (Jeremy Evans)

- Status changed from Assigned to Closed

Applied in changeset git|974d18fd0c13bd19120cad70187{5b646c901dff.

[ruby/resolv] Fix the fallback from UDP to TCP due to message truncation
If truncation is detected, return immediately from decode so that

the UDP connection can be retried with TCP, instead of failing to

decode due to trying to decode a truncated response.

Fixes [Bug #13513]

https://github.com/ruby/resolv/commit/0de996dbca

Files

resolv-monkey-tc.rb 757 Bytes 04/26/2017 iamasmith (Andrew Smith)
